drop TYPE IF EXISTS getPedidoFabricacion_type CASCADE;
CREATE TYPE getPedidoFabricacion_type AS (
	c1 varchar,
	c2 varchar,
	c3 varchar,
	c4 varchar,
	c5 varchar,
	c6 varchar,
	c7 varchar,
	c8 varchar,
	c9 varchar,
	c10 varchar,
	c11 varchar,
	c12 varchar
);
CREATE OR REPLACE FUNCTION getPedidoFabricacion(tipo_reporte integer, order_id integer) 
RETURNS SETOF getPedidoFabricacion_type AS $$
DECLARE 
	r1 getPedidoFabricacion_type%ROWTYPE;
	r2 record;
	r3 record;
	r4 record;
	r5 record;
	r_stock getProductStock_type%ROWTYPE;
	LdM1 varchar;
	description varchar;
	query varchar := '';
	query_1 varchar := '';
	query_2 varchar := '';
	query_new_line varchar := '';
	report_name varchar := '';
	count_line integer := 0;
	r_stock_real numeric := 0.0;
	r_stock_futuro numeric := 0.0;
	r_stock_disponible numeric := 0.0;
	r_stock_asignado numeric := 0.0;
	r_stock_pendiente numeric := 0.0;
BEGIN
	DROP TABLE IF EXISTS r_celdas;
	CREATE TEMPORARY TABLE r_celdas(
		c1 varchar,
		c2 varchar,
		c3 varchar,
		c4 varchar,
		c5 varchar,
		c6 varchar,
		c7 varchar,
		c8 varchar,
		c9 varchar,
		c10 varchar,
		c11 varchar,
		c12 varchar
	);
	query_new_line := 'INSERT INTO r_celdas SELECT '' ''::varchar,'' ''::varchar,'' ''::varchar,'' ''::varchar,'' ''::varchar,'' ''::varchar,'' ''::varchar,'' ''::varchar,'' ''::varchar,'' ''::varchar,'' ''::varchar,'' ''::varchar';
	IF tipo_reporte = 1 THEN		
		report_name := 'Reporte Pedido de Fabricacion';		
	ELSIF tipo_reporte = 2 THEN
			report_name := 'Reporte Modulo de produccion';
	END IF;
	IF tipo_reporte != 1 THEN
		query_2 := ', (SELECT distinct po.create_date::DATE
						FROM procurement_order po
						WHERE po.move_id in (SELECT sm_1.id AS move_id 
							FROM stock_move sm_1 
							LEFT JOIN stock_picking sp_1 ON (sm_1.picking_id = sp_1.id) WHERE sp_1.sale_id = so.id) 
						AND po.state in (''done'', ''running'')) AS fecha_excepcion';
	END IF;
	IF tipo_reporte = 3 THEN
		query := '
			, (SELECT COALESCE(replace(p.default_code, ''"'', '' ''), '' '') FROM mrp_bom b LEFT JOIN product_product p ON (b.product_id = p.id)WHERE b.bom_id = mp.bom_id) AS mp_name,
			(SELECT COALESCE(b.product_qty, 0) FROM mrp_bom b WHERE b.bom_id = mp.bom_id) AS mp_qty';
		query_1 := ' AND pp.default_code like ''%PM-%'' AND pc.id = 7';
		report_name := 'Reporte Materia Prima';
	END IF;
	INSERT INTO r_celdas SELECT
		report_name::varchar;
	EXECUTE query_new_line;
	--Genera el nombre del Cliente, num pedido, fecha pedido
	FOR r2 IN EXECUTE 'SELECT so.id, so.name AS client_order_ref, so.date_order, so.commitment_date, rp.name'||query_2||'
		FROM sale_order so 
		LEFT JOIN res_partner rp ON (so.partner_id = rp.id)
		WHERE so.id = '||order_id||';'
	LOOP
		IF tipo_reporte = 1 THEN
			INSERT INTO r_celdas SELECT 'No. Pedido',r2.client_order_ref::varchar,' '::varchar,' '::varchar,'Fecha Pedido:',r2.date_order::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar;
			INSERT INTO r_celdas SELECT 'Cliente',''||r2.name||''::varchar,' '::varchar,' '::varchar,'Fecha Entrega:',r2.commitment_date::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar;
		ELSIF tipo_reporte = 2 THEN
			INSERT INTO r_celdas SELECT 'No. Pedido',r2.client_order_ref::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,'Fecha Pedido:',''||r2.date_order||''::varchar,' '::varchar,' '::varchar,' '::varchar;
			INSERT INTO r_celdas SELECT 'Cliente',''||r2.name||''::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,'Fecha Entrega:',''||r2.commitment_date||''::varchar,' '::varchar,' '::varchar,' '::varchar;
			INSERT INTO r_celdas SELECT ''::varchar,''::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,'Fecha de Excepcion de Abastecimientos',r2.fecha_excepcion::varchar,' '::varchar,' '::varchar,' '::varchar;
		ELSIF tipo_reporte = 3 THEN
			INSERT INTO r_celdas SELECT 'No. Pedido',r2.client_order_ref::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,'Fecha Pedido:',r2.date_order::varchar;
			INSERT INTO r_celdas SELECT 'Cliente',r2.name::varchar,''::varchar,''::varchar,''::varchar,''::varchar,''::varchar,' '::varchar,' '::varchar,' '::varchar,'Fecha Entrega:',r2.commitment_date::varchar;
			INSERT INTO r_celdas SELECT ''::varchar,''::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,'Fecha de Excepcion de Abastecimientos',r2.fecha_excepcion::varchar;
		END IF;
		EXECUTE query_new_line;
		EXECUTE query_new_line;
		-- Genera el nombre de las lineas de los equipos
		FOR r3 IN EXECUTE 'SELECT 
				COALESCE(mb.id, 0) AS bom_id,
				COALESCE(po.move_id, 0) AS po_move_id,
				COALESCE(pp.id, 0) AS product_id,
				COALESCE(sm.id, 0) AS move_id,
				COALESCE(mp.move_prod_id, 0) AS move_production,
				COALESCE(mp.id, 0) AS production_id,
				COALESCE(mp.picking_id, 0) AS picking_id,
				COALESCE(sm.sale_line_id, 0) AS order_line_id,
				COALESCE(sm.product_qty, 0) AS order_line_qty,
				COALESCE(replace(pp.default_code, ''"'', '' ''), '' '') AS product_code,
				COALESCE(replace(mb.name, ''"'', '' ''), '' '') AS bom_name,
				(SELECT COALESCE(replace(p.name, ''"'', '' ''), '' '') FROM stock_picking p WHERE p.id = mp.picking_id) AS picking_name,
				COALESCE(replace(mp.name, ''"'', '' ''), '' '') AS production_name
			FROM stock_move sm
			LEFT JOIN stock_picking sp ON (sm.picking_id = sp.id)
			LEFT JOIN product_product pp ON (sm.product_id = pp.id)
			LEFT JOIN mrp_production mp ON (mp.move_prod_id = sm.id)
			LEFT JOIN procurement_order po ON (po.move_id = sm.id)
			LEFT JOIN mrp_bom mb ON (po.bom_id = mb.id)
			where 
				sp.sale_id = '||order_id||' AND sm.state <> ''cancel'';'
		LOOP
			IF tipo_reporte = 1 THEN
				INSERT INTO r_celdas SELECT 'Cantidad','Equipos','Modulos','Nombre de la Lista de Material','No. INT.','No.FABRICACION',' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar;
				INSERT INTO r_celdas SELECT r3.order_line_qty::varchar,r3.product_code::varchar,' '::varchar,r3.bom_name::varchar,r3.picking_name::varchar,r3.production_name::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar;
			ELSE
				INSERT INTO r_celdas SELECT 'Cantidad','Equipos','Nombre de la Lista de Material','No. int','No. FABRICACION.',' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar;
				INSERT INTO r_celdas SELECT r3.order_line_qty::varchar,r3.product_code::varchar,r3.bom_name::varchar,r3.picking_name::varchar,r3.production_name::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar;
			END IF;
			-- Genera el nombre de los modulos
			count_line := 0;		
			FOR r4 IN EXECUTE 'SELECT
					COALESCE(po.move_id, 0) AS po_move_id,
					COALESCE(sm.id, 0) AS move_id0,
					COALESCE(sm1.id, 0) AS move_id,
					COALESCE(sm1.product_id, 0) AS product_id,
					COALESCE(mp.move_prod_id, 0) AS move_production,
					COALESCE(mp.id, 0) AS production_id, 
					COALESCE(mp.picking_id, 0) AS picking_id,
					COALESCE(round(CAST(mp.product_qty AS numeric), 2), 0) AS product_qty,
					COALESCE(replace(pp.default_code, ''"'', '' ''), '' '') AS product_code,
					COALESCE(replace(mb.name, ''"'', '' ''), '' '') AS bom_name,
					COALESCE(replace(sp.name, ''"'', '' ''), '' '') AS picking_name,
					COALESCE(replace(mp.name, ''"'', '' ''), '' '') AS production_name	
				FROM 
					mrp_production_move_ids mpm
					left join stock_move sm on (mpm.move_id = sm.id)
					left join stock_move sm1 on (sm.id = sm1.move_dest_id)
					LEFT JOIN mrp_production mp ON (sm1.id = mp.move_prod_id)
					LEFT JOIN stock_picking sp ON (mp.picking_id = sp.id)
					LEFT JOIN procurement_order po ON (sm1.id = po.move_id)
					LEFT JOIN mrp_bom mb on (mp.bom_id = mb.id)
					LEFT JOIN product_product pp ON (sm1.product_id = pp.id)
					LEFT JOIN product_template pt ON (pp.product_tmpl_id = pt.id)
				WHERE mpm.production_id = '||r3.production_id||' AND pt.supply_method <> ''service'' AND sm1.state <> ''cancel''
				ORDER BY pt.supply_method, picking_name;'
			LOOP
				IF tipo_reporte = 1 THEN
					INSERT INTO r_celdas SELECT	r4.product_qty::varchar,' '::varchar,r4.product_code::varchar,r4.bom_name::varchar,r4.picking_name::varchar,r4.production_name::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar;
				ELSE
					IF tipo_reporte = 2 THEN
						FOR r_stock IN EXECUTE 'SELECT * FROM getProductStock('||r4.product_id||', '||r4.move_id||')'
						LOOP
							IF r4.product_qty > 0 THEN
								r_stock_real := r_stock.s_real;
								r_stock_futuro := r_stock.s_futuro;
								r_stock_disponible := r_stock.s_disponible;
								r_stock_asignado := r_stock.s_asignado;
								r_stock_pendiente := r_stock.s_pendiente;
							ELSE
								r_stock_real := 0.0;
								r_stock_futuro := 0.0;
								r_stock_disponible := 0.0;
								r_stock_asignado := 0.0;
								r_stock_pendiente := 0.0;
							END IF;
						END LOOP;
						IF r4.product_qty > 0 OR count_line = 0 THEN
							EXECUTE query_new_line;
							INSERT INTO r_celdas SELECT 'Cantidad','Modulos','Nombre de la lista de material','No. INT','No. Fabricacion','Cant En Stock','Stock Futuro','Cant Disponible','Cant. Asignada','Por Producir','Recibio por produccion','Fecha recibido';	
						END IF;
						IF r4.product_qty > 0 THEN
							INSERT INTO r_celdas SELECT r4.product_qty::varchar,r4.product_code::varchar,r4.bom_name::varchar,r4.picking_name::varchar,r4.production_name::varchar,r_stock_real::varchar,r_stock_futuro::varchar,r_stock_disponible::varchar,r_stock_asignado::varchar,r_stock_pendiente::varchar,' '::varchar,' '::varchar;						
							INSERT INTO r_celdas SELECT 'Cantidad','Modelo','Descripcion','No. INT','No. Fabricacion','No. OC','Stock Real','Stock Futuro','Cant Disponible','Cant. Asignada','Pendiente (Comprar / Producir)','Separado';
						ELSE
							INSERT INTO r_celdas SELECT r4.product_qty::varchar,r4.product_code::varchar,r4.bom_name::varchar,r4.picking_name::varchar,r4.production_name::varchar,r_stock_real::varchar,r_stock_futuro::varchar,r_stock_disponible::varchar,r_stock_asignado::varchar,r_stock_pendiente::varchar,' '::varchar,' '::varchar;						
						END IF;
						ELSE
						IF r4.product_qty > 0 OR count_line = 0 THEN
							EXECUTE query_new_line;
							INSERT INTO r_celdas SELECT 'Cantidad', 'Modulos', 'Nombre de la Lista de Material', 'No. int','No. FABRICACION.',' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar;
						END IF;
						IF r4.product_qty > 0 THEN
							INSERT INTO r_celdas SELECT r4.product_qty::varchar,r4.product_code::varchar,r4.bom_name::varchar,r4.picking_name::varchar,r4.production_name::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar;
							INSERT INTO r_celdas SELECT 'Cantidad','Modelo','Descripcion','Materia Prima','Long. (PLG por pieza)','No. Int. ','No. Fabricacion ','Pieza a cortar ','Long. por pieza a cortar ','Mat cortado','Recibio Maquinado','Recibe almacen';
						ELSE
							INSERT INTO r_celdas SELECT r4.product_qty::varchar,r4.product_code::varchar,r4.bom_name::varchar,r4.picking_name::varchar,r4.production_name::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar;
						END IF;
					END IF;
					-- Imprime la lista de componentes.
					FOR r5 IN EXECUTE 'SELECT
							po.id AS procurement_id,
							sm.id AS move_id,
							po.move_id as m_id,
							mp.move_prod_id,
							sm.product_id,
							pt.type AS product_type,
							pt.supply_method AS product_method,
							pt.procure_method AS product_procure,
							COALESCE(mp.id, 0) AS production_id, 
							COALESCE(mp.picking_id, 0) AS picking_id,
							COALESCE(round(CAST(sm.product_qty AS numeric), 3), 0) AS product_qty,							
							COALESCE(replace(pp.default_code, ''"'', '' ''), '' '') AS product_code,
							COALESCE(replace(pt.name, ''"'', '' ''), '' '') AS product_name,
							CASE 
								WHEN char_length(sp.name) > 0 THEN COALESCE(replace(sp.name, ''"'', '' ''), '' '') 
								-- ELSE (SELECT COALESCE(replace(p.name, ''"'', '' ''), '' '') AS picking_name FROM stock_picking p WHERE p.purchase_id = po.purchase_id) 
							END AS picking_name,								
							COALESCE(replace(mp.name, ''"'', '' ''), '' '') AS production_name,
							CASE
								WHEN po.procure_method = ''make_to_stock'' and COALESCE(sm.state, '' '') = ''assigned'' THEN ''Asignado de stock''
								WHEN po.procure_method = ''make_to_stock'' and COALESCE(sm.state, '' '') <> ''assigned'' THEN ''De stock''
								WHEN COALESCE(sm.state, '' '') <> '' '' and sm.state = ''assigned'' and po.message = ''from stock: products assigned.'' THEN  ''Producto asignado de stock''
								WHEN COALESCE(sm.state, '' '') <> '' '' and sm.state = ''assigned'' and po.message <> ''from stock: products assigned.'' THEN  po.message
								ELSE (SELECT CASE WHEN o.state = ''draft'' THEN ''SP | '' || o.name  ELSE o.name END FROM purchase_order o WHERE o.id = po.purchase_id)
							END AS purchase_name,
							pc.name AS category_name,
							CASE 
								WHEN pc.id = 16 THEN 1
								WHEN pc.id = 18 THEN 2
								WHEN pc.id = 8 THEN 3
								WHEN pc.id = 7 THEN 4
							ELSE 5
							END AS categ_order
							'||query||'
						FROM stock_move sm
						LEFT JOIN procurement_order po ON (sm.id = po.move_id)
						LEFT JOIN mrp_production mp ON (sm.id = mp.move_prod_id)
						LEFT JOIN stock_picking sp ON (mp.picking_id = sp.id)
						LEFT JOIN product_product pp ON (sm.product_id = pp.id)
						LEFT JOIN product_template pt ON (pp.product_tmpl_id = pt.id)
						LEFT JOIN product_category pc ON (pt.categ_id = pc.id)						
						WHERE sm.picking_id = '||r4.picking_id||' AND pt.supply_method != ''service'' AND sm.state <> ''cancel''
						'||query_1||'
						ORDER BY pt.supply_method, categ_order;'
					LOOP
						IF tipo_reporte = 2 THEN
							FOR r_stock IN EXECUTE 'SELECT * FROM getProductStock('||r5.product_id||', '||r5.move_id||')'
							LOOP
								INSERT INTO r_celdas SELECT r5.product_qty::varchar,r5.product_code::varchar,r5.product_name::varchar,r5.picking_name::varchar,r5.production_name::varchar,r5.purchase_name::varchar,r_stock.s_real::varchar,r_stock.s_futuro::varchar,r_stock.s_disponible::varchar,r_stock.s_asignado::varchar,r_stock.s_pendiente::varchar,' '::varchar;
							END LOOP;
						ELSE
							INSERT INTO r_celdas SELECT r5.product_qty::varchar,r5.product_code::varchar,r5.product_name::varchar,r5.mp_name::varchar,r5.mp_qty::varchar,r5.picking_name::varchar,r5.production_name::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar,' '::varchar;
						END IF;
					END LOOP;
				END IF;
				count_line := count_line + 1;
			END LOOP;
			EXECUTE query_new_line;
		END LOOP;
	END LOOP;
	FOR r2 IN SELECT * FROM r_celdas
	LOOP
		RETURN NEXT r2;
	END LOOP;
END
$$ language 'plpgsql';

--SELECT * FROM getPedidoFabricacion(2, 233);
